//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Interop.Client.BasicDataTypesTest
{
    
    
    /// <summary>
    /// Provides commands and properties to set or respectively get all SiLA Basic Data Types via command parameters or property responses respectively.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "test")]
    [Tecan.Sila2.SilaIdentifierAttribute("BasicDataTypesTest")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Basic Data Types Test")]
    public partial interface IBasicDataTypesTest
    {
        
        /// <summary>
        /// Returns the String value 'SiLA2_Test_String_Value'.
        /// </summary>
        string StringValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Integer value 5124.
        /// </summary>
        long IntegerValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Real value 3.1415926.
        /// </summary>
        double RealValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Boolean value true.
        /// </summary>
        bool BooleanValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Date value 05.08.2022 respective 08/05/2018, timezone +2.
        /// </summary>
        System.DateTimeOffset DateValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Time value 12:34:56, timezone +2.
        /// </summary>
        System.TimeSpan TimeValue
        {
            get;
        }
        
        /// <summary>
        /// Returns the Timestamp value 2022-08-05 12:34:56, timezone +2.
        /// </summary>
        System.DateTimeOffset TimestampValue
        {
            get;
        }
        
        /// <summary>
        /// Receives a String value and returns the String value that has been received.
        /// </summary>
        /// <param name="stringValue">The String value to be returned.</param>
        /// <returns>The String value that has been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValue")]
        string EchoStringValue(string stringValue);
        
        /// <summary>
        /// Receives an Integer value and returns the Integer value that has been received.
        /// </summary>
        /// <param name="integerValue">The Integer value to be returned.</param>
        /// <returns>The Integer value that has been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValue")]
        long EchoIntegerValue(long integerValue);
        
        /// <summary>
        /// Receives a Real value and returns the Real value that has been received.
        /// </summary>
        /// <param name="realValue">The Real value to be returned.</param>
        /// <returns>The Real value that has been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValue")]
        double EchoRealValue(double realValue);
        
        /// <summary>
        /// Receives a Boolean value and returns the Boolean value that has been received.
        /// </summary>
        /// <param name="booleanValue">The Boolean value to be returned.</param>
        /// <returns>The Boolean value that has been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValue")]
        bool EchoBooleanValue(bool booleanValue);
        
        /// <summary>
        /// Receives a Date value and returns the Date value that has been received.
        /// </summary>
        /// <param name="dateValue">The Date value to be returned.</param>
        /// <returns>The Date value that has been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValue")]
        System.DateTimeOffset EchoDateValue(System.DateTimeOffset dateValue);
        
        /// <summary>
        /// Receives a Time value and returns the Time value that has been received.
        /// </summary>
        /// <param name="timeValue">The Time value to be returned.</param>
        /// <returns>The Time value that has been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValue")]
        System.TimeSpan EchoTimeValue(System.TimeSpan timeValue);
        
        /// <summary>
        /// Receives a Timestamp value and returns a message containing the Timestamp value that has been received.
        /// </summary>
        /// <param name="timestampValue">The Timestamp value to be returned.</param>
        /// <returns>The Timestamp value that has been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValue")]
        System.DateTimeOffset EchoTimestampValue(System.DateTimeOffset timestampValue);
    }
}
